import * as i0 from '@angular/core';
import { InjectionToken, NgModule, Injectable, Inject } from '@angular/core';
import { CommonModule } from '@angular/common';
import { __awaiter } from 'tslib';
import algoliasearch from 'algoliasearch';

const CONFIG = new InjectionToken('config');

class AlgoliaModule {
    static forRoot(config) {
        return {
            ngModule: AlgoliaModule,
            providers: [{ provide: CONFIG, useValue: config }],
        };
    }
}
AlgoliaModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AlgoliaModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaModule, imports: [CommonModule] });
AlgoliaModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [CommonModule],
                }]
        }] });

class AlgoliaService {
    constructor(config) {
        this.config = config;
    }
    /**
     *
     * @param indexName
     * @param query
     * @param options
     * @throws when config undefined
     */
    search(indexName, query, requestOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.config) {
                throw Error('config undefined');
            }
            const client = algoliasearch(this.config.app_id, this.config.search_api_key);
            const index = client.initIndex(indexName);
            const res = yield index.search(query, requestOptions);
            return res;
        });
    }
}
AlgoliaService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaService, deps: [{ token: CONFIG }], target: i0.ɵɵFactoryTarget.Injectable });
AlgoliaService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.2", ngImport: i0, type: AlgoliaService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG]
                    }] }];
    } });

/*
 * Public API Surface of ng-algoliasearch
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AlgoliaModule, AlgoliaService };
//# sourceMappingURL=ng-algoliasearch.mjs.map
